<template>
  <div>
    <div class="row">
      <div class="col-xs-12 col-md-6">
        <el-input
          v-model="search"
          placeholder="Rechercher sur le nom"
        />
      </div>
    </div>
    <div class="row">
      <el-table
        ref="dsnfilesTable"
        :data="pagedAndFilteredDsnfiles"
        :default-sort="{prop: 'createdAt', order: 'descending'}"
        border
        stripe
        style="width: 100%"
        @selection-change="handleSelectionChange"
      >
        <el-table-column
          prop="createdAt"
          label="Date de transmission"
        >
          <template slot-scope="scope">
            {{ scope.row.createdAt.date | beautifulDateWithHour }}
          </template>
        </el-table-column>
        <el-table-column
          prop="name"
          label="Nom"
        />
        <el-table-column
          prop="status"
          label="Statut"
        >
          <template slot-scope="scope">
            <check-icon v-if="scope.row.status==='ok'" />
            <info-icon v-if="scope.row.status==='en_cours'" />
            <error-icon v-if="scope.row.status!=='en_cours' && scope.row.status!=='ok'" />
            {{ scope.row.status | dsnFileStatusLabelFromCode }}
            <simple-loader
              v-if="scope.row.status==='en_cours'"
            />
          </template>
        </el-table-column>
        <el-table-column
          prop="id"
          label="SIRET - Mois de déclaration - Nombre de matricule(s)"
          min-width="300"
        >
          <template slot-scope="scope">
            <p v-if="scope.row.declarations.length > 3">
              <el-button
                type="text"
                @click="seeMore(scope.row.declarations)"
              >
                Voir les {{ scope.row.declarations.length }} éléments
              </el-button>
            </p>
            <p
              v-for="(declaration, declarationIndex) in scope.row.declarations"
              v-else
              :key="declaration.id"
            >
              {{ scope.row.declarations[declarationIndex].siret }} - {{ declaration.firstOfMonth.date | beautifulDate }} - {{ declaration.personnelNumbersCount }}
            </p>
          </template>
        </el-table-column>
        <el-table-column
          prop="delete"
          label=""
          min-width="50"
        >
          <template slot-scope="scope">
            <click-button
              v-if="scope.row.status === 'ok'"
              :disabled="isLoading"
              @click="confirmDeleteChoice(scope.row)"
            >
              <template #content>
                <remove-icon />
              </template>
            </click-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <div class="row">
      <el-pagination
        :current-page.sync="currentPage"
        :page-size="pageSize"
        layout="total, prev, pager, next"
        :total="filteredDsnfiles.length"
        @current-change="handleCurrentChange"
      />
    </div>
    <div class="row">
      <p style="font-style: italic;">
        Ces données sont mises à jour automatiquement,
        100 éléments les plus récents affichés
      </p>
    </div>
    <dsn-file-delete-choice-modal
      @okClicked="setChoiceAndconfirmDeleteDsnFile(true)"
      @koClicked="setChoiceAndconfirmDeleteDsnFile(false)"
    />
    <confirmation-modal-delete
      id="confirmationModalDelete"
      text="Êtes-vous sûr de vouloir supprimer ce fichier ?"
      @okClicked="performDeleteDsnFile"
    />
  </div>
</template>

<script>
import ClickButton from "../../../components/Button/ClickButton";
import DsnFileDeleteChoiceModal from "../../../components/Modal/DsnFileDeleteChoiceModal";
import ErrorIcon from "../../../components/Icon/ErrorIcon";
import InfoIcon from "../../../components/Icon/InfoIcon";
import CheckIcon from "../../../components/Icon/CheckIcon";
import SimpleLoader from "../../../components/Loader/SimpleLoader";
import RemoveIcon from "../../../components/Icon/RemoveIcon";
import ConfirmationModalDelete from "../../../components/Modal/ConfirmationModal";
import VanillaToasts from "vanillatoasts";
import {mapActions, mapGetters} from "vuex";

export default {
  name: "DsnFileTable",
  components: {
    ClickButton,
    DsnFileDeleteChoiceModal,
    ErrorIcon,
    InfoIcon,
    CheckIcon,
    SimpleLoader,
    RemoveIcon,
    ConfirmationModalDelete,
  },
  data() {
    return {
      search: '',
      selectedDsnFile: {
        id: null,
        name: null,
        status: null,
        createdAt: null,
        declarations: [],
      },
      multipleSelection: [],
      currentPage: 1,
      pageSize: 10,
    }
  },
  computed: {
    ...mapGetters([
      'dsnFiles',
      'isLoading',
      'dsnFile',
    ]),
    pagedAndFilteredDsnfiles() {
      return !this.search
        ?
        this.dsnFiles.slice(this.pageSize * this.currentPage - this.pageSize, this.pageSize * this.currentPage)
        :
        this.dsnFiles.filter(dsnFile => dsnFile.name.toLowerCase().includes(this.search.toLowerCase())).slice(this.pageSize * this.currentPage - this.pageSize, this.pageSize * this.currentPage)

    },
    filteredDsnfiles() {
      return this.search ? this.dsnFiles.filter(dsnFile => dsnFile.name.toLowerCase().includes(this.search.toLowerCase())) : this.dsnFiles
    },
  },
  methods: {
    ...mapActions([
      'deleteDsnFile'
    ]),
    handleCurrentChange(val) {
      this.currentPage = val
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    confirmDeleteDsnFile(dsnFileAndIndex) {
      this.dsnFileAndIndex = dsnFileAndIndex
      $('#confirmationModalDelete').modal({keyboard:false,backdrop:'static'})
    },
    confirmDeleteChoice(dsnFile) {
      this.selectedDsnFile = dsnFile
      $('#dsnFileDeleteChoiceModal').modal({keyboard:false,backdrop:'static'})
    },
    setChoiceAndconfirmDeleteDsnFile(choice) {
      this.deleteDataChoice = choice
      this.confirmDeleteDsnFile(this.dsnFileAndIndex)
    },
    performDeleteDsnFile() {
      this.deleteDsnFile({dsnFile: this.selectedDsnFile, choice: this.deleteDataChoice})
        .then(()=>{
          VanillaToasts.create({
            title: 'Suppression fichier',
            text: 'Opération effectuée avec succès',
            type: 'success',
            timeout: 5000,
          });
          this.deleteDataChoice = false
          this.selectedDsnFile = null
        })
    },
    seeMore(declaration) {
      let text = ''
      declaration.forEach(declaration => {
        text += declaration.siret - declaration.firstOfMonth.date - declaration.personnelNumbersCount + '<br>'
      });
      text = text.substring(0, text.length - 2)
      this.$alert(text, 'Liste des SIRETS', {
        confirmButtonText: 'Retour'
      });
    }
  }
}
</script>

<style scoped>
.row {
  margin-top: 2vh;
}
</style>